//-*-c++-*-
#ifndef INCLUDED_WallFollowing_h_
#define INCLUDED_WallFollowing_h_

#include "Behaviors/BehaviorBase.h"
#include "Motion/MotionManager.h"
#include "Behaviors/Controls/FileBrowserControl.h"
#include "Motion/MotionSequenceMC.h"
#include "Motion/EmergencyStopMC.h"
#include "Motion/LedMC.h"
#include "SoundPlay/SoundManager.h"
#include "Motion/MMAccessor.h"
#include "Shared/TimeET.h"
#include "Shared/Config.h"
#include <string>


class WallFollowing : public BehaviorBase {
public:
	//! constructor
	WallFollowing() : BehaviorBase("WallFollowing"), headpointer_id(MotionManager::invalid_MC_ID), walker_id(MotionManager::invalid_MC_ID), 
					 leds_id(MotionManager::invalid_MC_ID), isBtnPressed(false), isStopped(true), inTransition(false), counter(0)
	{
	
		sndman->PlayFile("3yips.wav");
	
	}

	virtual void DoStart();
	virtual void DoStop();
	virtual void processEvent(const EventBase& event);

	void GetToSteppin(float fwd, float side, float rotate);
	void PanHead();
	void SetHeadPan(float pan);

	static std::string getClassDescription() { return "The Blind man's shuffle"; }
	virtual std::string getDescription() const { return getClassDescription(); }
	
protected:

	
	MotionManager::MC_ID headpointer_id; //!< a HeadPointerMC object
	MotionManager::MC_ID walker_id;      //!< a WalkMC object
	MotionManager::MC_ID leds_id;		//
	
	bool isBtnPressed;
	bool isStopped;
	bool inTransition;
	int counter;

	SharedObject<LedMC> leds_mc;
};

/*
*	Author: Jeremiah Savage
*	Last Update: 08/04/2005
*	Description: This Behavior will follow the left side of a wall
*/
#endif
